




unit
   t_drawobj;
   
interface
   
type
   e_drawtype = (line,circle,rectange,string);
    
   p_point2d = ^t_point2d; 
   t_point2d = record
                 x,y : integer;
               end;
   
   p_colormap = ^t_colormap;
   t_colormap = record
                  normal,selected,hidden : integer;
                end;            
var
   drawobj_colormap : array[0..31] of t_colormap;
   
type                  	
   p_drawobj = ^t_drawobj;                     
   t_drawobj = object
                 next : p_drawobj;
                 anchor : t_point2d;  
                 cmap	: p_colormap;
                 kind   : e_drawtype;
                 
                 color : integer;
                 selected : boolean;
                 
                 constructor Init(c : p_colormap; a : p_point2d; n : p_drawobj);
                 destructor Done();
                 
                 procedure Draw;	 		virtual;
                 procedure Rotate(deg : integer);	virtual;
                 procedure MoveTo(p : p_point2d);	virtual;
                 procedure Select(p : p_drawobj); 	virtual;
                 procedure UnSelect(p : p_drawobj);	virtual;
            
                 procedure Show;
                 procedure ShowSelected; 
                 procedure Hide; 	 
                 
                 procedure Delete(p : p_drawobj);
                 procedure Insert(p : p_drawobj);
               end;	   
   

implementation

procedure t_drawobj.Init;
begin
  cmap := c;
  anchor.x := a^.x;
  anchor.y := a^.y;
  next := n; 
  selected := false;
end;

procedure t_drawobj.Select(p : p_drawobj);
begin
  if (next <> NIL)
     then begin
            if (next = p)
               then next^.selected := true
               else next^.Select(p);
          end;
end;

procedure t_drawobj.UnSelect(p : p_drawobj);
begin
  if (next <> NIL)
     then begin
            if (next = p)
               then next^.selected := false
               else next^.UnSelect(p);
          end;
end;

procedure t_drawobj.Insert(p : p_drawobj);
begin
  if (next = NIL)
     then next := p
     else next^.Insert(p);
end;

procedure t_drawobj.Delete(p : p_drawobj);
var
   delp : p_drawobj;
begin
  if (next <> NIL)
     then begin
            if (next = p)
               then begin
                      delp = next;
                      next = next^.next;
                      
                      delp^.next = NIL;
                      delp^.Done;
                      delete(delp);
                    end
               else next^.Delete(p);     
          end;
end;

procedure t_drawobj.Draw;
begin
end;

procedure t_drawobj.Show;
begin
  if (not(selected))
     then begin
            color := cmap^.normal;
            Draw;
          end;  

  if (next <>NIL)
     then next^.Show;
end;

procedure t_drawobj.ShowSelected;
begin
  if (selected)
     then begin
            color := cmap^.selected;  
            Draw;
          end;
          
  if (next <> NIL)
     then next^.ShowSelected;   
end;

procedure t_drawobj.Hide;
begin
  color := cmap^.hidden;
  Draw;
end;

               
begin
end.   
