/* 
 * Thomas Pantzer: t_cursor.cc, v0.1b  8.11.98 0:58 
 * 
 * 
 * Copyright 1998 by Thomas Pantzer
 * 
 * Permission to use, copy, modify, and distribute this software for noncommercial 
 * use and without fee is hereby granted, provided that the above copyright notice 
 * appear in all copies and that both that copyright notice and this permission 
 * notice appear in supporting documentation, and that the name of the Author not be 
 * used in advertising or publicity pertaining to distribution of the software 
 * without specific, written prior permission. The Author makes no representations about
 * the suitability of this software for any purpose.  It is provided "as is" 
 * without expressed or implied warranty. 
 * 
 * 
 * pantec@informatik.uni-leipzig.de   (Thomas Pantzer) 
 * 
 */




#include "t_cursor.h"

void t_cursor::Anchor(t_vector2d *np)
{
  t_line *L;
  t_vector2d d;
  
  L = (t_line *)first;
  
  d.Init(np);
  d.Sub(&anchor);
  
  anchor.Init(np);

  while (L != NULL)
    {
     L->anchor.Add(&d);
     L->endpoint.Add(&d);
    
     L = (t_line *)L->next;
    }
}

void t_cursor::Init(t_colormap *c, t_vector2d *a, t_drawobj *n, int l, int wi)
{
  t_line *L[5];
  t_vector2d p[10];
  
  t_drawgrp::Init(c,a,n,wi);
  kind = _cursor;
  
  len = l;
  
  p[9].Init(2,2);
  p[8].Init(2,-2);
  
  for (int i=0; i<3; i++)
    p[i].Init(a);
  
  p[0].Add(&p[9]);
  p[1].Add(&p[8]);

  p[2].Sub(&p[9]);
  p[3].Sub(&p[8]);
  
  for (int i=0; i<4; i++)
    p[4+i].Init(&p[i]);
  
  for (int i=0; i<len; i++)
    {
     p[4].Add(&p[9]);
     p[5].Add(&p[8]);

     p[6].Sub(&p[9]);
     p[7].Sub(&p[8]);
    }
  
  for (int i=0; i<4; i++)
    L[i] = new t_line;
  
  L[4] = NULL;
  
  for (int i=0; i<4; i++)
    {
     L[i]->Init(c,&p[i],L[i+1],&p[i+4],wi);
//     L[i]->SetSelected(true);
//     L[i]->selected = true;
    }

  first = L[0];
  kind = _cursor;
  
  first->OpaqueAll(true);
  opaque = true;

  first->SelectAll(false);
  selected = false;
}


void t_cursor::Opaque(char b)
{
   opaque = true;
   first->OpaqueAll(true);
}

void t_cursor::Select(char b)
{
   selected = false;
   first->SelectAll(false);
}


double t_cursor::Distance(t_vector2d *P)
{
   return 1000000000.0;		// don't choose cursor as nearest object
}

void t_cursor::Done()
{
  t_line *L,*delp;
  
  L = (t_line *)first;
  while (L != NULL)
    {
     delp = L;
     L = (t_line *)L->next;
     
     delete delp;    
    }
}
