/* 
 * Thomas Pantzer: t_drawobj.h, v0.1b  8.11.98 0:58 
 * 
 * 
 * Copyright 1998 by Thomas Pantzer
 * 
 * Permission to use, copy, modify, and distribute this software for noncommercial 
 * use and without fee is hereby granted, provided that the above copyright notice 
 * appear in all copies and that both that copyright notice and this permission 
 * notice appear in supporting documentation, and that the name of the Author not be 
 * used in advertising or publicity pertaining to distribution of the software 
 * without specific, written prior permission. The Author makes no representations about
 * the suitability of this software for any purpose.  It is provided "as is" 
 * without expressed or implied warranty. 
 * 
 * 
 * pantec@informatik.uni-leipzig.de   (Thomas Pantzer) 
 * 
 */

// Header for module t_drawobj, generated by p2c 1.21alpha-07.Dec.93
#ifndef T_DRAWOBJ_H
#define T_DRAWOBJ_H



#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include "t_vector.h"
#include "xfgc/graphix.h"


enum e_drawtype {
      	 _basic,
      	 _group,
      	 
      	 _line,
      	 _circle,
      	 _rectangle,
      	 _polygon,
      	 _triangle,
      	 _arc,
      	 _string, 
      	 
      	 _cursor, 
      	 _resistor,
      	 _arrow    
};


struct t_colormap {
  int normal, selected, hidden;
};


enum color_type {ct_normal, ct_selected, ct_hidden, ct_opaque};




class t_drawobj {
public:
  class t_drawobj *next;
//  class t_drawobj *border;
  class t_vector2d anchor;
  t_colormap *cmap;
  e_drawtype kind;

  int /*color,*/width;
  char selected,hidden,opaque;

  void Init(t_colormap *, class t_vector2d *, class t_drawobj *, int );
  virtual void AnchorAdd(class t_vector2d *);
  virtual void Anchor(class t_vector2d *);
//  virtual t_vector2d *t_drawobj::Anchor(void);
  virtual void NewAnchor(void);   
  t_vector2d *Anchor(void);

  virtual void Done(void);

  virtual void Draw(color_type ct);
  virtual void DrawAll(color_type ct);

  virtual void Rotate(class t_vector2d *M, class t_vector2d &CSR);
  virtual void RotateAll(class t_vector2d *M, class t_vector2d &CSR);

//  virtual void Rotate(class t_drawobj *,class t_vector2d *M, class t_vector2d &CSR);

  virtual void MoveRel(class t_vector2d *);
  virtual void MoveTo(class t_vector2d *);


  virtual void SetOpaqueView(void);          	      	 // all
  virtual void ClearOpaqueView(void);          	      	 // all
  virtual void SetSelectedView(void);          	      	 // all
  virtual void ClearSelectedView(void);        	      	 // all


  virtual void SaveTo(int fd);
  virtual void SaveAllTo(int fd);

  virtual void Select(char b);        
  virtual void SelectAll(char b);        

  virtual void Opaque(char b);
  virtual void OpaqueAll(char b);

/*
  void SetSelected(char b);          	      	 // all
  void SetSelected(char b, class t_drawobj *);   // object
  void SetOpaque(char b);          	      	 // all
  void SetOpaque(char b, class t_drawobj *);     // object
*/

/*  
  virtual void Select(void);		        // all
  virtual void Select(class t_drawobj *);	
  virtual void Deselect(void);			// all						
  virtual void Deselect(class t_drawobj *);	// object
*/
  
  virtual double Distance(class t_vector2d *);

  t_drawobj *Distance(double ,t_vector2d * ,t_drawobj *);

  virtual void Show(void);
  virtual void ShowAll(void);

  virtual void Hide(void);
  virtual void HideAll(void);

  void Delete(class t_drawobj *);
  void Unchain(class t_drawobj *);
  void Insert(class t_drawobj *);
//  void SetOpaque(char op);

  int Count(void);
private:

//  void Opaque(void);  
};


#ifdef T_DRAWOBJ_G
# define vextern
#else
# define vextern extern
#endif


vextern t_colormap drawobj_colormap[32];


#undef vextern

#endif /*T_DRAWOBJ_H*/

// End.
