/* 
 * Thomas Pantzer: t_line.cc, v0.1b  8.11.98 0:58 
 * 
 * 
 * Copyright 1998 by Thomas Pantzer
 * 
 * Permission to use, copy, modify, and distribute this software for noncommercial 
 * use and without fee is hereby granted, provided that the above copyright notice 
 * appear in all copies and that both that copyright notice and this permission 
 * notice appear in supporting documentation, and that the name of the Author not be 
 * used in advertising or publicity pertaining to distribution of the software 
 * without specific, written prior permission. The Author makes no representations about
 * the suitability of this software for any purpose.  It is provided "as is" 
 * without expressed or implied warranty. 
 * 
 * 
 * pantec@informatik.uni-leipzig.de   (Thomas Pantzer) 
 * 
 */

// Output from p2c 1.21alpha-07.Dec.93, the Pascal-to-C translator
// From input file "/home/pantec/src/objdraw/t_line.p"


// #include <p2c/p2c.h>


//#include "graphix.h"

#define T_LINE_G
#include "t_line.h"



void t_line::Init(t_colormap *c, t_vector2d *a, t_drawobj *n, t_vector2d *ep, int w)
{
  t_drawobj::Init(c, a, n, w);

  endpoint.Init(ep);
  kind = _line;
}


void t_line::SaveTo(int fd)
{
   t_drawobj::SaveTo(fd);

   char st[256];
   sprintf(st,"\tep:(%d,%d)",endpoint.GetX(),endpoint.GetY());
   write(fd,st,strlen(st));
}

void t_line::Draw(color_type ct)
{
#ifdef DEBUG
  fprintf(stderr, "t_line::Draw()\t");    
#endif
  t_drawobj::Draw(ct);
  
  int h[2] = {-1,1};
  
  if (width == 3)
     {
      for (int a=0; a<2; a++)
        for (int b=0; b<2; b++)
          for (int c=0; c<2; c++)
            for (int d=0; d<2; d++)
              drawline(anchor.GetX()+h[a], anchor.GetY()+h[b], 
                       endpoint.GetX()+h[c], endpoint.GetY()+h[d]);
     }
    
  drawline(anchor.GetX(), anchor.GetY(), endpoint.GetX(), endpoint.GetY());
#ifdef DEBUG
  fprintf(stderr,"drawline (%d,%d)->(%d,%d)\n",
                 anchor.GetX(), anchor.GetY(), endpoint.GetX(), endpoint.GetY());
#endif
}


void t_line::Turn(t_vector2d *V)
{
   anchor.Turn(V);
   endpoint.Turn(V);
}

void t_line::Rotate(t_vector2d *V, t_vector2d &CSV)
{
#ifdef DEBUG
   fprintf(stderr,"t_line::Rotate(0x%08lx)\n",(long)this); 
#endif
   anchor.Rotate(V,CSV);
   endpoint.Rotate(V,CSV);
}


void t_line::AnchorAdd(t_vector2d *p)
{
   t_drawobj::AnchorAdd(p);
   endpoint.Add(p);   
}

// End.
