/* 
 * Thomas Pantzer: t_string.cc, v0.1b  8.11.98 0:58 
 * 
 * 
 * Copyright 1998 by Thomas Pantzer
 * 
 * Permission to use, copy, modify, and distribute this software for noncommercial 
 * use and without fee is hereby granted, provided that the above copyright notice 
 * appear in all copies and that both that copyright notice and this permission 
 * notice appear in supporting documentation, and that the name of the Author not be 
 * used in advertising or publicity pertaining to distribution of the software 
 * without specific, written prior permission. The Author makes no representations about
 * the suitability of this software for any purpose.  It is provided "as is" 
 * without expressed or implied warranty. 
 * 
 * 
 * pantec@informatik.uni-leipzig.de   (Thomas Pantzer) 
 * 
 */

// Output from p2c 1.21alpha-07.Dec.93, the Pascal-to-C translator
// From input file "/home/pantec/src/objdraw/t_line.p"


// #include <p2c/p2c.h>

#include <string.h>

//#include "graphix.h"

#define T_STRING_G
#include "t_string.h"

void t_string::SaveTo(int fd)
{
   t_drawobj::SaveTo(fd);

   char st[256];
   sprintf(st,"\ttx:[%s]\tft:%d",text,font);
   write(fd,st,strlen(st));
}


void t_string::Init(t_colormap *c, t_vector2d *a, t_drawobj *n, int f)
{
  t_drawobj::Init(c, a, n, f);

  font = f;
  kind = _string;
  
  strcpy(text,"");
}

void t_string::Init(t_colormap *c, t_vector2d *a, t_drawobj *n, const char *tt,int f)
{
  t_string::Init(c, a, n, f);

  if (tt != NULL)
     strcpy(text,tt);
}


void t_string::Draw(color_type ct)
{
  t_drawobj::Draw(ct);
  
  VScr.SetTextStyle(font);
  OutTextXY(anchor.GetX(), anchor.GetY(), text);
}


void t_string::Add(char c)
{
  int l = strlen(text);
  
  if ((l < 120) && (l>=0))
     {
      text[l] = c;
      l++;
      text[l] = '\0';
     } 
}


void t_string::Trunc(void)
{
   int l = strlen(text);
   
   if ((l>1) && (l < 120))
      l -= 1;
    else
      return;  
   
   text[l] = '\0';
}

// End.
